#include "stdafx.h"
#include "Comecocos.h"
#include <fstream.h>


#include <stdlib.h>
#include <string.h>

#include "ComecocosDoc.h"
//#include "DialogoFinJuego.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//**********************************************************************************************//
//*                        Elegimos los mensajes que queremos atender                          *//
//**********************************************************************************************//
IMPLEMENT_DYNCREATE(CComecocosDoc, CDocument)

BEGIN_MESSAGE_MAP(CComecocosDoc, CDocument)
	//{{AFX_MSG_MAP(CComecocosDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//**********************************************************************************************//
//*                               Constructor y Destructor                                     *//
//**********************************************************************************************//
CComecocosDoc::CComecocosDoc() 
{
   fstream fileout;
   fstream filein;
   char dato;

   int i;


   //Cargamos los datos de las opciones
   filein.open("opciones.dat", ios::in | ios::out | ios::binary | ios::nocreate);
    

   //Si no existe archivo de opciones lo creamos por defecto
   if(!filein) 
   {
      fileout.open("opciones.dat", ios::out | ios::binary);
      
      VIDAS = 3;
      TIMER = 40;
      PANTALLA = 1;
      DIFICULTAD = 2;
      GRAFICOS = 0;
   
      fileout.write((char *) (&VIDAS), sizeof(char));
      fileout.write((char *) (&TIMER), sizeof(char));
      fileout.write((char *) (&PANTALLA), sizeof(char));
      fileout.write((char *) (&GRAFICOS), sizeof(char));
      fileout.write((char *) (&DIFICULTAD), sizeof(char));

      for (i=0; i<5; i++) 
      {
         strcpy(vectorPuntuaciones[i].nombre, "No Record");
         vectorPuntuaciones[i].puntos = 0;
         fileout.write(reinterpret_cast<char *> (&vectorPuntuaciones[i]), sizeof(SRecord));
      }

      fileout.close();  
   }

   //Si existe lo leemos
   else
   {   

      filein.read((char *) (&dato), sizeof(char)); VIDAS = (int) dato;

      filein.read((char *) (&dato), sizeof(char)); TIMER = (int) dato;
      filein.read((char *) (&dato), sizeof(char)); PANTALLA = (int) dato;
      filein.read((char *) (&dato), sizeof(char)); GRAFICOS = (int) dato;
      filein.read((char *) (&dato), sizeof(char)); DIFICULTAD = (int) dato;

      for (i=0; i<5; i++) 
      {
         filein.read(reinterpret_cast<char *> (&vectorPuntuaciones[i]), sizeof(SRecord));
      }

      filein.close();  
   }


   filein.open("pantallas.dat", ios::in | ios::out | ios::binary | ios::nocreate);
   
   //Si no existe un archivo con las pantallas salimos del programa pq no podemos ejecutar el juego
   if(!filein) 
   {
      exit(-1);
   }


   //Leemos el numero de pantallas que existe en el archivo
   filein.read((char *) (&dato), sizeof(char));
   MAX_PANTALLAS = (int) dato;

   filein.close();

   estadoJuego = -1;
}


CComecocosDoc::~CComecocosDoc() {}


//**********************************************************************************************//
//*                Funcion que se ejecuta la primera vez que se crea la ventana                *//
//**********************************************************************************************//
BOOL CComecocosDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

   //cargaPuntuaciones();


   //Si la aplicacion acaba de ser abierta preparamos el juego para poder darle a Nuevo->Juego
   if (estadoJuego == -1) { estadoJuego = 0; }

   //Si la aplicacion le acabamos de dar a Nuevo->Juego
   else if (estadoJuego != -1)
   {
      //Inicializamos las teclas a no pulsadas
      for (int i=0; i<4; i++) bTeclas[i] = false;

      //Inicializamos las variables de puntuaciones y vidas y estado de juego
	   pantallaActual = PANTALLA;
      estadoJuego = 0;
      pacman.contador = 100; //Activamos la cuenta atras
      tipoFruta = 0;

      vidas = VIDAS;
      puntuacion = 0; //Reiniciamos la puntuacion
      puntuacionSiguiente = 1000;

      nivelDificultad = DIFICULTAD;

      //Creamos pantalla 1
      iniciaPantalla(pantallaActual);

   }
   return true;
}
	


//**********************************************************************************************//
//*                     Rellena la matriz con la informacion del fichero                       *//
//**********************************************************************************************//
bool CComecocosDoc::cargaPantalla(char nPantalla)
{
   ifstream file;
   int dato, i, j;
   int dif = nivelDificultad;

   fstream filein;
   

   filein.open("pantallas.dat", ios::in | ios::out | ios::binary);
  
   filein.read(reinterpret_cast<char *> (&MAX_PANTALLAS), sizeof(char));

   if (nPantalla > MAX_PANTALLAS)
   {
      filein.close();
      return false;
   }

   //Leemos pantallas hasta llegar a la nuestra
   for(i=0; i<nPantalla; i++) filein.read(reinterpret_cast<char *> (&mapaPantalla), sizeof(mapaPantalla));

   filein.close();



   nBolitas = 0;
   setPuertas(false); //Ponemos a falso las puertas direccionables

   for (j=0; j<16; j++)
   {
      for (i=0; i<16; i++)
      {
         dato = mapaPantalla[i][j];

         //Creamos los fantasmas si el tile es una casilla 22
         if (dato == 99) 
         {
            for (int k=0; k< 4; k++)
            {
               enemigo[k].dir = rand()%4;
               enemigo[k].x = i*32 + rand()%8 * 4;// + 4;
               enemigo[k].y = j*32 - rand()%8 * 4;// - 4;
               enemigo[k].tipo = k;
               enemigo[k].estado = 0;
               enemigo[k].inteligencia = (dif > 0);
               enemigo[k].Enemigo = true;
               dif--;
            }

            salidaFantasma.x = i*32;
            salidaFantasma.y = j*32;

            mapaPantalla[i][j] = 0;
         }

         //Creamos el pacman si el tile es una casilla 23
         else if (dato == 98) 
         {
            pacman.dir = 1;
            pacman.x = i*32;
            pacman.y = j*32;
            pacman.tipo = 0;
            pacman.estado = 0;
            pacman.Enemigo = false;

            salidaPacman.x = i*32;
            salidaPacman.y = j*32;

            mapaPantalla[i][j] = 1;
         }

         else if (dato == 2) nBolitas++;

         //Si hay puertas activamos la variable de puertas
         else if (dato > 25 && dato < 30) setPuertas(true);
      }
   }

	return TRUE;
}



//**********************************************************************************************//
//*      Nos devuelve si es correcta o no la direccion tomada, es decir si se choca o no       *//
//**********************************************************************************************//
bool CComecocosDoc::compruebaDireccion(CComecocosDoc::SPersonaje p)
{
   bool ok = true;
   int nY = 0, nX = 0;
   char dato = 1;
   

   //Si es arriba o abajo
   if (p.dir%2 == 0)
   {
      //Si esta al limite de una casilla
      if (p.y%32 == 0)
      {
         nY = p.y/32;
         nX = p.x/32;
      

         //Comprobamos la siguiente casilla que vamos a acceder
         if (p.dir == 0) nY--;
         else nY++;

         dato = mapaPantalla[nX][nY];
      }
   }

   //Si se mueve derecha o izquierda
   else
   {
      //Si esta al limite de una casilla
      if (p.x%32 == 0)
      {
         nY = p.y/32;
         nX = p.x/32;
      

         //Comprobamos la siguiente casilla que vamos a acceder
         if (p.dir == 1) nX++;
         else nX--;

         dato = mapaPantalla[nX][nY];
      }
   }

   //Si se trata de una pared cambiamos su direccion   
   if ((dato > 3 && dato < 22) || (!p.Enemigo && dato == 0))
   {
      ok = false;
   }

   //Si es Pacman y la casilla es una puerta
   else if (!p.Enemigo && dato > 25 && dato < 30)
   {
      //Si tenemos la misma direccion que la puerta no pasa nada
      //Pero si tenemos distinta direccion, no podremos pasar
      if (p.dir != dato-26) ok = false;
   }

   
   //Si sale de la matriz por alguna puerta y es pacman devolvemos cierto, 
   //si es fantasma devolvemos false
   if (nX > 15 || nX < 0 || nY > 15 || nY < 0) 
   {
      if (p.Enemigo == false) ok = true; 
      else ok = false;
   }
   

   return ok;
}


//**********************************************************************************************//
//*               Controla los movimientos y la inteligencia de los fantasmas                  *//
//**********************************************************************************************//
void CComecocosDoc::manejaEnemigos()
{
//   TIMER = 1;
//   return;

   int vx, vy, vel; //Para calcular los desplazamientos
   char adir;
   bool ok;
   int i;
   int distancia;

   //Para los 4 fantasmas
   for (i=0; i<4; i++)
   {

      //Si el fantasma no esta muerto
      if (enemigo[i].estado < 2)
      {
         //Si esta miedoso, decrementamos el contador del miedo
         if (enemigo[i].estado == 1)
         {
            vel = 2;

            enemigo[i].contador--;
            //Si llegamos a 0 se le quita el miedo
            if (enemigo[i].contador <= 0) { enemigo[i].estado = 0; }
         }

         //Si todavia puede seguir andando hacia delante
         if (compruebaDireccion(enemigo[i]))
         {
            vx = 0; vy = 0; 

            //Si no esta miedoso la velocidad es 4, pero si no es multiplo de 4 no podemos
            //ponerle esa velocidad pq sino no llegaria a 32 exactos, debemos sumarle 2 para regularlo
            if (enemigo[i].estado == 0)
            {
               vel = 4;
               if (enemigo[i].x%4 != 0 || enemigo[i].y%4 != 0) vel = 2;
            }

            switch (enemigo[i].dir)
            {
               //Si el fantasma sube
               case 0: vy-=vel; break;
               case 1: vx+=vel; break;
               case 2: vy+=vel; break;
               case 3: vx-=vel; break;
            }

            //Lo movemos
            enemigo[i].x += vx; enemigo[i].y += vy;

            //Si se encuentra al principio de una casilla miramos si se puede hacer algo
            if ((enemigo[i].x % 32) == 0 && (enemigo[i].y % 32) == 0 && mapaPantalla[enemigo[i].x/32][enemigo[i].y/32] != 0)
            {
               //Calculamos la distancia del fantasma al pacman
               distancia = abs(enemigo[i].x - pacman.x);
               distancia += abs(enemigo[i].y - pacman.y);



               //Evaluamos la inteligencia del fantasma
               switch (enemigo[i].inteligencia)
               {
                  //Si no tiene cerebro lo que hacemos es elegir una ruta al azar
                  case 0:
                  {
                     //Comprobamos si puede cambiar su direccion
                     adir = enemigo[i].dir;
            
                     enemigo[i].dir = (enemigo[i].dir + 1) % 4;
                     ok = compruebaDireccion(enemigo[i]);
                     enemigo[i].dir = (enemigo[i].dir + 2) % 4;
                     ok |= compruebaDireccion(enemigo[i]);
            
                     enemigo[i].dir = adir;
            
                     //Si puede cambiar su direccion pq esta en un cruce, elegimos una direccion al azar
                     if (ok && rand()%2 == 0)
                     {
                        enemigo[i].dir = rand()%4;
                        while (compruebaDireccion(enemigo[i]) != true)
                           enemigo[i].dir = rand()%4;
                     }
   
                     break;
                  }

                  //Si piensa un poco, lo que hacemos es elegir un camino que nos acerque a pacman
                  case 1:
                  {
                     char eleccion[2];
                     bool op;
   
                     //Comprobamos si puede cambiar su direccion
                     adir = enemigo[i].dir;
            
                     //Si el enemigo esta asustado, trata de huir de pacman                     
                     if (enemigo[i].estado == 1 && distancia < 200)
                     {
                        if (enemigo[i].y > pacman.y) eleccion[0] = 2;
                        else eleccion[0] = 0;
                     
                        if (enemigo[i].x > pacman.x) eleccion[1] = 1;
                        else eleccion[1] = 3;
                     }
                     
                     //Si el enemigo quiere matar trata de acercarse a pacman                    
                     else
                     {
                        if (enemigo[i].y > pacman.y) eleccion[0] = 0;
                        else eleccion[0] = 2;
                     
                        if (enemigo[i].x > pacman.x) eleccion[1] = 3;
                        else eleccion[1] = 1;
                     } 
                     

                     op = (rand()%2 == 0);
   
                     //Elegimos una al azar de las dos posibles
                     enemigo[i].dir = eleccion[op];
                     ok = compruebaDireccion(enemigo[i]);
   
                     //Si no se puede elegir esa, elegimos la otra posibilidad
                     if (!ok)
                     {
                        enemigo[i].dir = eleccion[!op];
                        ok = compruebaDireccion(enemigo[i]);
   
                        if (!ok) enemigo[i].dir = adir;
                     }
                     break;
                  }
   
               }
            }
         }  

         //Si el fantasma no puede seguir andando, tiene que elegir otra ruta al azar
         else
         {
            while (compruebaDireccion(enemigo[i]) != true)
               enemigo[i].dir = rand()%4;
         }

      }

      //Si el fantasma esta muerto, lo movemos hacia el centro poco a poco
      else
      {
         if (enemigo[i].x < salidaFantasma.x) { enemigo[i].x += 2; enemigo[i].dir = 1; }
         else if (enemigo[i].x > salidaFantasma.x) { enemigo[i].x -= 2; enemigo[i].dir = 3; }
         else if (enemigo[i].y < salidaFantasma.y) { enemigo[i].y += 2; enemigo[i].dir = 2; }
         else if (enemigo[i].y > salidaFantasma.y) { enemigo[i].y -= 2; enemigo[i].dir = 0; }

         //Si ya hemos llegado lo revivimos
         if (enemigo[i].x == salidaFantasma.x && enemigo[i].y == salidaFantasma.y)
            enemigo[i].estado = 0;
      }
   }
}


//**********************************************************************************************//
//*                   Devuelve TRUE si el primer rectangulo choca con el segundo               *//
//**********************************************************************************************//
bool CComecocosDoc::esColision(CRect r0, CRect r1)
{
   int cx, cy;
   int ancho, alto;
   
   //Hallamos el punto medio del segundo rectangulo
   ancho = (r1.right - r1.left)/2;
   alto = (r1.bottom - r1.top)/2;

   cx = r1.left + ancho;
   cy = r1.top + alto;

   //Aumentamos en (ancho/2, alto/2) el primer rectangulo
   r0.top -= alto;
   r0.bottom += alto;
   r0.right += ancho;
   r0.left -= ancho;

   //Comprobamos si el punto central esta dentro del rectangulo r0
   if (cx > r0.left && cx < r0.right && cy > r0.top && cy < r0.bottom) return true;
   else return false;
}


//**********************************************************************************************//
//*               Controla los movimientos y los sucesos y eventos de Pacman                   *//
//**********************************************************************************************//
void CComecocosDoc::manejaPacman()
{
//   return;

   int nX, nY;
   int vx, vy;
   int vel = 4;
   char dir, adir;
   CRect r0, r1;

   pacman.contador--;
   if (pacman.contador < 0) pacman.contador = 300;

   tiempoFruta--;
   if (tiempoFruta < 0)
   {
      tiempoFruta = 200 + rand()%300 - (nivelDificultad*75);
      if (tipoFruta > 0) tipoFruta = 0;
      else 
      {
         char dato;
       
         do
         {
            posicionXFruta = rand()%16;
            posicionYFruta = rand()%16;

            dato = mapaPantalla[posicionXFruta][posicionYFruta];
         }
         while(dato == 0 || dato > 3);

         tipoFruta = rand()%2 + 1;
      }
   }

   //Si Pacman no esta en estado de muerto
   if (pacman.estado != 2)
   {
      vx = 0;
      vy = 0;

      dir = 5;

      //Comprobamos si se pulso alguna tecla
      for (int i=0; i<4; i++)
         if (bTeclas[i]) 
            dir = i;

      //*********************************//
      //Miramos sobre que casilla estamos
      //*********************************//
      nX = pacman.x / 32;
      nY = pacman.y / 32;

      //Si mas de la mitad del cuerpo esta en la siguiente casilla, miramos la siguiente
      //en vez de mirar la casilla actual
      if (pacman.x%32 > 15) nX++;
      else if (pacman.y%32 > 15) nY++;


      //Si estamos sobre una celda de direccion obligatoria
      if (mapaPantalla[nX][nY] > 21 && mapaPantalla[nX][nY] < 26)
      {
         //Si nuestra posicion es multiplo de 8 incrementamos la velocidad
         //Si es multiplo de 8 quiere decir, sumandole de 8 en 8 acabaremos en un cruce exacto de 32
         if (pacman.x%8 == 0 && pacman.y%8 == 0) vel = 8;

         dir = mapaPantalla[nX][nY] - 22; //La nueva direccion sera la que indique la casilla

         //Si la direccion es la misma que teniamos antes o sentido contrario lo cambiamos directamente
         if (dir%2 == pacman.dir%2) pacman.dir = dir;

         //Si es otra direccion, debemos esperar a estar dentro de un cruce para cambiarla
         else if ((pacman.x % 32) == 0 && (pacman.y % 32) == 0) pacman.dir = dir;
       
         dir = 5; //Anulamos cualquier pulsacion de tecla anterior
      }

      //Si estamos sobre una celda de una puerta direccional
      else if (mapaPantalla[nX][nY] > 25 && mapaPantalla[nX][nY] < 30)
      {
         switch (pacman.dir)
         {
            case 0: mapaPantalla[nX][nY] = 28; break;
            case 1: mapaPantalla[nX][nY] = 29; break;
            case 2: mapaPantalla[nX][nY] = 26; break;
            case 3: mapaPantalla[nX][nY] = 27; break;
         }
      }



      //Si se pulso alguna tecla comprobamos si la direccion es correcta
      if ((dir != 5 && (pacman.x % 32) == 0 && (pacman.y % 32) == 0) //Si estamos en una casilla entera
         || (dir == (pacman.dir + 2)%4 && (pacman.x % 4) == 0 && (pacman.y % 4) == 0)) //O si nuestra posicion es multiplo de 4 y hacemos un cambio de sentido
      {  
         adir = pacman.dir;
         pacman.dir = dir; //Si es correcta cambiamos la direccion

         //Si no es correcta, mantenemos la que teniamos antes
         if (compruebaDireccion(pacman) != true) pacman.dir = adir;
      }


      //Si Pacman puede seguir andando hacia delante
      if (compruebaDireccion(pacman) == true)
      {

         //Movemos el pacman
         switch (pacman.dir)
         {
            case 0: vy-=vel; break;
            case 1: vx+=vel; break;
            case 2: vy+=vel; break;
            case 3: vx-=vel; break;
         }  

         //Incrementamos su posicion
         pacman.x += vx;
         pacman.y += vy;

         //Si se sale de la matriz, entrara por el lado opuesto
         if (pacman.x > 15*32 + 16) pacman.x -= 16*32;
         else if (pacman.x < -16) pacman.x += 16*32;
     
         if (pacman.y > 15*32 + 16) pacman.y -= 16*32;
         else if (pacman.y < -16) pacman.y += 16*32;
   
         //Calculamos la casilla sobre la que estamos
         nX = pacman.x / 32;
         nY = pacman.y / 32;
     
         //Si la casilla es una bolita normal o especial
         //Y la boca del pacman coincide con la coordenada exacta de la bolita
         if ((mapaPantalla[nX][nY] == 2 || mapaPantalla[nX][nY] == 3) &&
            ((pacman.dir == 0 && pacman.y%32 < 8) || (pacman.dir == 3 && pacman.x%32 < 8) || pacman.dir == 1 || pacman.dir == 2))
         {
            //Si es una bola especial
            if (mapaPantalla[nX][nY] == 3)
            {
               //Ponemos todos los fantasmas que no estan muertos, en estado miedoso
               for (int i=0; i<4; i++)
               {
                  if (enemigo[i].estado != 2) 
                  {
                     enemigo[i].estado = 1;
                     enemigo[i].contador = 300; //Contador para controlar el tiempo q dura el miedo
                  }                  
               }
               puntuacion+=50+25*(nivelDificultad+1)/2; //Sumamos 5 puntos por coger la bolita especial
            }
            
            //Si es una bola normal
            else 
            {
               puntuacion+=10+5*(nivelDificultad+1)/2; //Sumamos 1 punto por coger la bolita normal
               nBolitas--; //Hay 1 bolita menos

               if (nBolitas <= 0)
               {
                  pacman.contador = 100;
                  estadoJuego = 4; //Juego Completado                  
               }
            }

            mapaPantalla[nX][nY] = 1; //Marcamos la casilla como vacia y pisable
            //El 0 es vacia y no pisable por pacman
         }

         //Si hemos chafado una fruta la quitamos
         if (nX == posicionXFruta && nY == posicionYFruta && tipoFruta > 0)
         {
            tiempoFruta = 0;

            if (tipoFruta == 1) puntuacion+=100+50*(nivelDificultad+1)/2;
            else puntuacion+=200+100*(nivelDificultad+1)/2;
         }
   
      }   

      //Comprobamos si se ha chocado con algun fantasma
      //Establecemos el rectangulo q cubre pacman
      r0.top = pacman.y;
      r0.bottom = pacman.y+32;

      r0.left = pacman.x;
      r0.right = pacman.x+32;

      //Para todos los fantasmas
      for (i=0; i<4; i++)
      {
         //Calculamos el rectangulo de cada fantasma
         r1.top = enemigo[i].y;
         r1.bottom = enemigo[i].y+32;

         r1.left = enemigo[i].x;
         r1.right = enemigo[i].x+32;
   
         //Si existe una colision
         if (esColision(r0,r1))
         {
            //Si el enemigo estaba en estado miedoso pacman se lo come, y lo ponemos en estado muerto
            if (enemigo[i].estado == 1)
            {
               enemigo[i].estado = 2;
               puntuacion += 50+25*(nivelDificultad+1)/2;
            }
   
            //Pero si no estaba en estado miedoso, el fantasma mata a pacman
            else if (enemigo[i].estado == 0)
            {
               //Ponemos el estado de pacman a muerto
               pacman.estado = 2;
               pacman.contador = 100; //Utilizamos el contador para calcular el tiempo de muerto
            }
         }
      }  

      pacman.tipo = (pacman.tipo + 1) % 9; //Incrementamos la animacion de abrir/cerrar boca
   }


   //Si pacman estaba muerto
   else
   {
      pacman.dir = (pacman.dir + 2) % 16; //Le damos vueltas para animarlo sin parar
      pacman.contador--; //Decrementamos el contador

      //Si se acabo el tiempo de la animacion
      if (pacman.contador <= 0)
      {
         //Inicializamos las variables de pacman

         estadoJuego = 2; //Pausamos el juego
         pacman.x = salidaPacman.x;
         pacman.y = salidaPacman.y;
         pacman.dir = 1;
         pacman.tipo = 0;
         pacman.estado = 0;
         pacman.contador = 50;
         
         vidas--; //Le quitamos una vida
         if (vidas <= 0) 
            estadoJuego = 3; //Si no le quedan vidas, se acabo el juego
         
         puntuacion -= 100+50*(nivelDificultad+1)/2; //Le quitamos 25 puntos por morir
         if (puntuacion < 0) puntuacion = 0; //Puntos negativos NO

         //Inicializamos todos los fantasmas que vuelvan a su sitio
         for (int k=0; k< 4; k++)
         {
            enemigo[k].dir = rand()%4;
            enemigo[k].x = salidaFantasma.x + rand()%8 * 4;// + 4;
            enemigo[k].y = salidaFantasma.y - rand()%8 * 4;// - 4;
            enemigo[k].estado = 0;
         }
      }
   }

   if (puntuacion > puntuacionSiguiente)
   {
      int k;

      k = puntuacionSiguiente/2 + 500;
      //puntuacionSiguiente += k;

      if (k > 5000) k = 5000;
      puntuacionSiguiente += k;

      vidas++;      
   }
}



//**********************************************************************************************//
//*               Inicializa las variables y carga la nueva pantalla                           *//
//**********************************************************************************************//
void CComecocosDoc::iniciaPantalla(char pantalla)
{
   int i;

   //Inicializamos las teclas a no pulsadas
   for (i=0; i<4; i++) bTeclas[i] = false;

   //Inicializamos las variables de puntuaciones y vidas y estado de juego
   pantallaActual = pantalla;
   estadoJuego = 0;
   pacman.contador = 100;
   tiempoFruta = rand()%500 + 500;
   tipoFruta = 0;

   //Creamos pantalla 
   if (cargaPantalla(pantalla)) 
   {
      estadoJuego = 2;
   } 
   else
   {
      estadoJuego = 0;    
   }
}



/////////////////////////////////////////////////////////////////////////////
// CComecocosDoc serialization

void CComecocosDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CComecocosDoc diagnostics

#ifdef _DEBUG
void CComecocosDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CComecocosDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CComecocosDoc commands


//**********************************************************************************************//
//*               Si cerramos el documento guardamos las opciones que habiamos elegido         *//
//**********************************************************************************************//
void CComecocosDoc::OnCloseDocument() 
{
   fstream fileout;
   int i;


   fileout.open("opciones.dat", ios::out | ios::binary);
               
   fileout.write((char *) (&VIDAS), sizeof(char));
   fileout.write((char *) (&TIMER), sizeof(char));
   fileout.write((char *) (&PANTALLA), sizeof(char));
   fileout.write((char *) (&GRAFICOS), sizeof(char));
   fileout.write((char *) (&DIFICULTAD), sizeof(char));

   for (i=0; i<5; i++) 
   {
      fileout.write(reinterpret_cast<char *> (&vectorPuntuaciones[i]), sizeof(SRecord));
   }

   fileout.close();  


   CDocument::OnCloseDocument();
}
