#if !defined(AFX_COMECOCOSDOC_H__8560F7D7_5668_4A0C_B267_1B76DD0D66A5__INCLUDED_)
#define AFX_COMECOCOSDOC_H__8560F7D7_5668_4A0C_B267_1B76DD0D66A5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CComecocosDoc : public CDocument
{
   //********************************//
   //*** Declaracion de atributos ***//
   //********************************//
   public:

	   /** yo **/
	  struct SRecord
	  {
		 char nombre[16];
		 int puntos;
	  };
	  /** **/

      struct SPersonaje
      {
         bool Enemigo; //Si esta activa es un enemigo, si esta desactivada es un amigo
         int x, y; //Posicion del fantasma
         char dir; //Direccion: 0-Arriba,  1-Derecha,  2-Abajo,   3-Izquierda
         char estado;  //Estado: 0-Normal,   1-Miedoso,    2-Muerto
         char tipo; //Tipo del fantasma
         int contador; //Se utiliza para varias cosas depende del estado y del tipo
         char inteligencia;
      };
      
      SPersonaje enemigo[4];
      SPersonaje pacman;
      char mapaPantalla[16][16]; //Matriz de 16x16 con 256 posibles valores
      SRecord vectorPuntuaciones[5];
      char posicionXFruta, posicionYFruta;
      char tipoFruta;
      int tiempoFruta;

      //***************************************************************//
      //Estas variables son para inicializarlas con los menus de configuracion
      int VIDAS, TIMER, PANTALLA, DIFICULTAD, GRAFICOS, MAX_PANTALLAS; 
      //***************************************************************//

   private: 
      struct SPunto
      {
         int x,y;
      };

      SPunto salidaFantasma, salidaPacman;
      char pantallaActual; //Numero de la pantalla actual
      bool bTeclas[4];
      int puntuacion, vidas, nBolitas;
      char estadoJuego;      
      char nivelDificultad;
      bool puertasDireccionables;
      int puntuacionSiguiente;

   //******************************//
   //*** Declaracion de metodos ***//
   //******************************//
   protected: // create from serialization only
      CComecocosDoc();
      DECLARE_DYNCREATE(CComecocosDoc)

   public:
      // Overrides
      // ClassWizard generated virtual function overrides
      //{{AFX_VIRTUAL(CComecocosDoc)
	public:
         virtual BOOL OnNewDocument();
         virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

      virtual ~CComecocosDoc();
      #ifdef _DEBUG
         virtual void AssertValid() const;
         virtual void Dump(CDumpContext& dc) const;
      #endif

      void manejaEnemigos(); //Controla a los enemigos, sus movimientos
      void manejaPacman(); //Controla los movimientos del personaje principal
   
      void setTecla(int t, bool estado) { bTeclas[t] = estado; }
      void setEstadoJuego(char e) { estadoJuego = e; }
      void setPuertas(bool ok) { puertasDireccionables = ok; }

      char getEstadoJuego() { return estadoJuego; }
      char getPantallaActual() { return pantallaActual; }
      int getPuntuacion() { return puntuacion; }
      int getVidas() { return vidas; }	  
	   int getDificultad() {return nivelDificultad; }
      bool getPuertas() { return puertasDireccionables; }

      void iniciaPantalla(char pantalla);


   private:
      bool compruebaDireccion(SPersonaje p);
      bool esColision(CRect r0, CRect r1);
      bool cargaPantalla(char nPantalla);
//      bool cargaPuntuaciones();

   // Generated message map functions
   protected:
	   //{{AFX_MSG(CComecocosDoc)
	//}}AFX_MSG
	   DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMECOCOSDOC_H__8560F7D7_5668_4A0C_B267_1B76DD0D66A5__INCLUDED_)
